#include "server_data_interact.h"
#include <engine_engine_number_9/baza_throw.h>

namespace iu9cawebchat {
    /* This is literally the most dumb and useless query */
    json::JSON internalapi_getMessageNeighbours(SqliteConnection& conn, int64_t uid, const json::JSON& Sent) {
        int64_t chatId = Sent["chatId"].g().asInteger().get_int();
        if (get_role_of_user_in_chat(conn, uid, chatId) == user_chat_role_deleted)
            een9_THROW("Authentication failure");
        bool dir_forward = Sent["direction"].g().asString() == "forward";
        int64_t amount = Sent["amount"].g().asInteger().get_int();
        if (amount < 0)
            een9_THROW("Incorrect amount");
        json::JSON Recv;
        Recv["status"] = json::JSON(0l);
        Recv["messages"] = json::JSON(json::array);
        std::vector<json::JSON>& messages = Recv["messages"].g().asArray();
        if (dir_forward) {
            int64_t curMsg = Sent["id"].g().asInteger().get_int();
            if (curMsg < 0)
                een9_THROW("forward message lookup from the beginning of chat is not supported yet");
            while (true) {
                /* At this point, curMsg is non-negative */
                std::pair<int64_t, RowMessage_Content> nxt = lookup_message_content_rev_side(conn, chatId, curMsg);
                if (nxt.first < 0)
                    break;
                messages.emplace_back();
                json::JSON& message = messages.back();
                message["id"] = json::JSON(nxt.first);
                message["previous"] = json::JSON(curMsg);
                message["content"]["text"] = json::JSON(nxt.second.text);
                message["content"]["isSystem"] = json::JSON(nxt.second.isSystem);
                message["content"]["sender"] = json::JSON(nxt.second.senderUserId);
                curMsg = nxt.first;
            }
        } else {
            int64_t curMsg = Sent["previousMsgId"].g().asInteger().get_int();
            while (curMsg >= 0) {
                RowMessage_Content curRow = lookup_message_content(conn, chatId, curMsg);
                messages.emplace_back();
                json::JSON& message = messages.back();
                message["id"] = json::JSON(curMsg);
                message["previous"] = json::JSON(curRow.previous);
                message["content"]["text"] = json::JSON(curRow.text);
                message["content"]["isSystem"] = json::JSON(curRow.isSystem);
                message["content"]["sender"] = json::JSON(curRow.senderUserId);
                curMsg = curRow.previous;
            }
        }
        return Recv;
    }
}
